Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4080)
@@ -451,429 +477,432 @@
     }
     
     /**
-     * Control servlet response depending on the action parameter specified
-     */
-    private void handleGetOrPost(HttpServletRequest request,
-            HttpServletResponse response) throws ServletException, IOException {
-        MetaCatUtil util = new MetaCatUtil();
-        Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
-        
-        // Each time metacat is called, see if it has been configured,
-        // and if not, then go ahead and configure it's options
-        boolean configured = MetaCatUtil.getOption("configured").equals("true");
-        if (!configured) {
-            configureMetacat(request, response);
-            return;
-        }
-        
-        /*
-         * logMetacat.debug("Connection pool size: "
-         * +connPool.getSizeOfDBConnectionPool(),10);
-         * logMetacat.debug("Free DBConnection number: "
-         */
-        //If all DBConnection in the pool are free and DBConnection pool
-        //size is greater than initial value, shrink the connection pool
-        //size to initial value
-        DBConnectionPool.shrinkDBConnectionPoolSize();
-        
-        //Debug message to print out the method which have a busy DBConnection
-        try {
-            DBConnectionPool pool = DBConnectionPool.getInstance();
-            pool.printMethodNameHavingBusyDBConnection();
-        } catch (SQLException e) {
-            logMetacat.error("Error in MetacatServlet.handleGetOrPost: "
-                    + e.getMessage());
-            e.printStackTrace();
-        }
-        
-        String ctype = request.getContentType();
-        if (ctype != null && ctype.startsWith("multipart/form-data")) {
-            handleMultipartForm(request, response);
-        } else {
-            
-            String name = null;
-            String[] value = null;
-            String[] docid = new String[3];
-            Hashtable params = new Hashtable();
-            
-            // Check if this is a simple read request that doesn't use the "action" syntax
-            // These URLs are of the form:
-            //            http://localhost:8180/knb/metacat/docid/skinname
-            //     e.g.,  http://localhost:8180/knb/metacat/test.1.1/knb
-            String pathInfo = request.getPathInfo();
-            if (pathInfo != null) {
-                String[] path = pathInfo.split("/");
-                if (path.length > 1) {
-                    String docidToRead = path[1];
-                    String docs[] = new String[1];
-                    docs[0] = docidToRead;
-                    logMetacat.debug("READING DOCID FROM PATHINFO: " + docs[0]);
-                    params.put("docid", docs);
-                    String skin = null;
-                    if (path.length > 2) {
-                        skin = path[2];
-                        String skins[] = new String[1];
-                        skins[0] = skin;
-                        params.put("qformat", skins);
-                    }
-                    handleReadAction(params, request, response, "public", null, null);
-                    return;
-                }
-            }
-            
-            Enumeration paramlist = request.getParameterNames();
-            while (paramlist.hasMoreElements()) {
-                
-                name = (String) paramlist.nextElement();
-                value = request.getParameterValues(name);
-                
-                // Decode the docid and mouse click information
-                // THIS IS OBSOLETE -- I THINK -- REMOVE THIS BLOCK 4/12/2007 MBJ
-                if (name.endsWith(".y")) {
-                    docid[0] = name.substring(0, name.length() - 2);
-                    params.put("docid", docid);
-                    name = "ypos";
-                }
-                if (name.endsWith(".x")) {
-                    name = "xpos";
-                }
-                
-                params.put(name, value);
-            }
-            
-            //handle param is emptpy
-            if (params.isEmpty() || params == null) { return; }
-            
-            //if the user clicked on the input images, decode which image
-            //was clicked then set the action.
-            if(params.get("action") == null){
-                PrintWriter out = response.getWriter();
-                response.setContentType("text/xml");
-                out.println("<?xml version=\"1.0\"?>");
-                out.println("<error>");
-                out.println("Action not specified");
-                out.println("</error>");
-                out.close();
-                return;
-            }
-            
-            String action = ((String[]) params.get("action"))[0];
-            logMetacat.info("Action is: " + action);
-            
-            // This block handles session management for the servlet
-            // by looking up the current session information for all actions
-            // other than "login" and "logout"
-            String username = null;
-            String password = null;
-            String[] groupnames = null;
-            String sess_id = null;
-            name = null;
-            
-            // handle login action
-            if (action.equals("login")) {
-                PrintWriter out = response.getWriter();
-                handleLoginAction(out, params, request, response);
-                out.close();
-                
-                // handle logout action
-            }   else if (action.equals("logout")) {
-                PrintWriter out = response.getWriter();
-                handleLogoutAction(out, params, request, response);
-                out.close();
-                
-                // handle shrink DBConnection request
-            } else if (action.equals("shrink")) {
-                PrintWriter out = response.getWriter();
-                boolean success = false;
-                //If all DBConnection in the pool are free and DBConnection
-                // pool
-                //size is greater than initial value, shrink the connection
-                // pool
-                //size to initial value
-                success = DBConnectionPool.shrinkConnectionPoolSize();
-                if (success) {
-                    //if successfully shrink the pool size to initial value
-                    out.println("DBConnection Pool shrunk successfully.");
-                }//if
-                else {
-                    out.println("DBConnection pool not shrunk successfully.");
-                }
-                //close out put
-                out.close();
-                
-                // aware of session expiration on every request
-            } else {
-                HttpSession sess = request.getSession(true);
-                logMetacat.info("session.isnew: " + sess.isNew() + "    params.hassessid: " + params.containsKey("sessionid"));
-                if (sess.isNew() && !params.containsKey("sessionid")) {
-                    // session expired or has not been stored b/w user requests
-                    logMetacat.info(
-                            "The session is new or no sessionid is assigned. The user is public");
-                    username = "public";
-                    sess.setAttribute("username", username);
-                    sess_id = (String)sess.getId();
-                    sess.setAttribute("sessionid", sess_id);
-                    sessionHash.put(sess_id, sess);
-                } else {
-                    logMetacat.info("The session is either old or "
-                            + "has sessionid parameter");
-                    try {
-                        if (params.containsKey("sessionid")) {
-                            sess_id = ((String[]) params.get("sessionid"))[0];
-                            logMetacat.info("in has sessionid "
-                                    + sess_id);
-                            if (sessionHash.containsKey(sess_id)) {
-                                logMetacat.info("find the id "
-                                        + sess_id + " in hash table");
-                                sess = (HttpSession) sessionHash.get(sess_id);
-                            }
-                        } else {
-                            //this makes sure there is a session object for public sessions
-                            sess_id = sess.getId();
-                            sessionHash.put(sess_id, sess);
-                        }
-                    } catch (IllegalStateException ise) {
-                        logMetacat.error(
-                                "Error in handleGetOrPost: this shouldn't "
-                                + "happen: the session should be valid: "
-                                + ise.getMessage());
-                    }
-                    
-                    username = (String) sess.getAttribute("username");
-                    logMetacat.info("The user name from session is: "
-                            + username);
-                    password = (String) sess.getAttribute("password");
-                    groupnames = (String[]) sess.getAttribute("groupnames");
-                    name = (String) sess.getAttribute("name");
-                }
-                
-                //make user user username should be public
-                if (username == null || (username.trim().equals(""))) {
-                    username = "public";
-                }
-                logMetacat.info("The user is : " + username);
-            }
-            // Now that we know the session is valid, we can delegate the
-            // request
-            // to a particular action handler
-            if (action.equals("query")) {
-            	ServletOutputStream streamOut = response.getOutputStream();
-                PrintWriter out = new PrintWriter(streamOut);
-                handleQuery(out, params, response, username, groupnames,
-                        sess_id);
-                out.close();
-            } else if (action.equals("squery")) {
-            	ServletOutputStream streamOut = response.getOutputStream();
-                PrintWriter out = new PrintWriter(streamOut);
-                if (params.containsKey("query")) {
-                    handleSQuery(out, params, response, username, groupnames,
-                            sess_id);
-                    out.close();
-                } else {
-                    out.println(
-                            "Illegal action squery without \"query\" parameter");
-                    out.close();
-                }
-            } else if ( action.trim().equals("spatial_query")) {
-                
-                logMetacat.debug("******************* SPATIAL QUERY ********************");
-                ServletOutputStream streamOut = response.getOutputStream();
-                PrintWriter out = new PrintWriter(streamOut);
-                handleSpatialQuery(out, params, response, username, groupnames, sess_id);
-                out.close();
-                
-            } else if (action.equals("export")) {
-                
-                handleExportAction(params, response, username,
-                        groupnames, password);
-            } else if (action.equals("read")) {
-                handleReadAction(params, request, response, username, password,
-                        groupnames);
-            } else if (action.equals("readinlinedata")) {
-                handleReadInlineDataAction(params, request, response, username,
-                        password, groupnames);
-            } else if (action.equals("insert") || action.equals("update")) {
-                PrintWriter out = response.getWriter();
-                if ((username != null) && !username.equals("public")) {
-                    handleInsertOrUpdateAction(request, response,
-                            out, params, username, groupnames);
-                } else {
-                    response.setContentType("text/xml");
-                    out.println("<?xml version=\"1.0\"?>");
-                    out.println("<error>");
-                    out.println("Permission denied for user " + username + " "
-                            + action);
-                    out.println("</error>");
-                }
-                out.close();
-            } else if (action.equals("delete")) {
-                PrintWriter out = response.getWriter();
-                if ((username != null) && !username.equals("public")) {
-                    handleDeleteAction(out, params, request, response, username,
-                            groupnames);
-                } else {
-                    response.setContentType("text/xml");
-                    out.println("<?xml version=\"1.0\"?>");
-                    out.println("<error>");
-                    out.println("Permission denied for " + action);
-                    out.println("</error>");
-                }
-                out.close();
-            } else if (action.equals("validate")) {
-                PrintWriter out = response.getWriter();
-                handleValidateAction(out, params);
-                out.close();
-            } else if (action.equals("setaccess")) {
-                PrintWriter out = response.getWriter();
-                handleSetAccessAction(out, params, username);
-                out.close();
-            } else if (action.equals("getaccesscontrol")) {
-                PrintWriter out = response.getWriter();
-                handleGetAccessControlAction(out, params, response, username,
-                        groupnames);
-                out.close();
-            } else if (action.equals("getprincipals")) {
-                PrintWriter out = response.getWriter();
-                handleGetPrincipalsAction(out, username, password);
-                out.close();
-            } else if (action.equals("getdoctypes")) {
-                PrintWriter out = response.getWriter();
-                handleGetDoctypesAction(out, params, response);
-                out.close();
-            } else if (action.equals("getdtdschema")) {
-                PrintWriter out = response.getWriter();
-                handleGetDTDSchemaAction(out, params, response);
-                out.close();
-            } else if (action.equals("getlastdocid")) {
-                PrintWriter out = response.getWriter();
-                handleGetMaxDocidAction(out, params, response);
-                out.close();
-            } else if (action.equals("getalldocids")) {
-                PrintWriter out = response.getWriter();
-                handleGetAllDocidsAction(out, params, response);
-                out.close();
-            } else if (action.equals("isregistered")) {
-                PrintWriter out = response.getWriter();
-                handleIdIsRegisteredAction(out, params, response);
-                out.close();
-            } else if (action.equals("getrevisionanddoctype")) {
-                PrintWriter out = response.getWriter();
-                handleGetRevisionAndDocTypeAction(out, params);
-                out.close();
-            } else if (action.equals("getversion")) {
-                response.setContentType("text/xml");
-                PrintWriter out = response.getWriter();
-                out.println(Version.getVersionAsXml());
-                out.close();
-            } else if (action.equals("getlog")) {
-                handleGetLogAction(params, request, response, username, groupnames);
-            } else if (action.equals("getloggedinuserinfo")) {
-                PrintWriter out = response.getWriter();
-                response.setContentType("text/xml");
-                out.println("<?xml version=\"1.0\"?>");
-                out.println("\n<user>\n");
-                out.println("\n<username>\n");
-                out.println(username);
-                out.println("\n</username>\n");
-                if(name!=null){
-                    out.println("\n<name>\n");
-                    out.println(name);
-                    out.println("\n</name>\n");
-                }
-                if(MetaCatUtil.isAdministrator(username, groupnames)){
-                    out.println("<isAdministrator></isAdministrator>\n");
-                }
-                if(MetaCatUtil.isModerator(username, groupnames)){
-                    out.println("<isModerator></isModerator>\n");
-                }
-                out.println("\n</user>\n");
-                out.close();
-            } else if (action.equals("buildindex")) {
-                handleBuildIndexAction(params, request, response, username, groupnames);
-            } else if (action.equals("login") || action.equals("logout")) {
-                /*
-            } else if (action.equals("protocoltest")) {
-                String testURL = "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9";
-                try {
-                    testURL = ((String[]) params.get("url"))[0];
-                } catch (Throwable t) {
-                }
-                String phandler = System
-                        .getProperty("java.protocol.handler.pkgs");
-                response.setContentType("text/html");
-                PrintWriter out = response.getWriter();
-                out.println("<body bgcolor=\"white\">");
-                out.println("<p>Handler property: <code>" + phandler
-                        + "</code></p>");
-                out.println("<p>Starting test for:<br>");
-                out.println("    " + testURL + "</p>");
-                try {
-                    URL u = new URL(testURL);
-                    out.println("<pre>");
-                    out.println("Protocol: " + u.getProtocol());
-                    out.println("    Host: " + u.getHost());
-                    out.println("    Port: " + u.getPort());
-                    out.println("    Path: " + u.getPath());
-                    out.println("     Ref: " + u.getRef());
-                    String pquery = u.getQuery();
-                    out.println("   Query: " + pquery);
-                    out.println("  Params: ");
-                    if (pquery != null) {
-                        Hashtable qparams = MetaCatUtil.parseQuery(u.getQuery());
-                        for (Enumeration en = qparams.keys(); en
-                                .hasMoreElements();) {
-                            String pname = (String) en.nextElement();
-                            String pvalue = (String) qparams.get(pname);
-                            out.println("    " + pname + ": " + pvalue);
-                        }
-                    }
-                    out.println("</pre>");
-                    out.println("</body>");
-                    out.close();
-                } catch (MalformedURLException mue) {
-                    System.out.println(
-                            "bad url from MetacatServlet.handleGetOrPost");
-                    out.println(mue.getMessage());
-                    mue.printStackTrace(out);
-                    out.close();
-                }
-                 */
-            } else {
-                PrintWriter out = response.getWriter();
-                out.println("<?xml version=\"1.0\"?>");
-                out.println("<error>");
-                out.println(
-                        "Error: action not registered.  Please report this error.");
-                out.println("</error>");
-                out.close();
-            }
-            
-            //util.closeConnections();
-            // Close the stream to the client
-            //out.close();
-            
-            // Schedule the sitemap generator to run periodically
-            scheduleSitemapGeneration(request);
-        }
-    }
+	 * Control servlet response depending on the action parameter specified
+	 */
+	private void handleGetOrPost(HttpServletRequest request,
+			HttpServletResponse response) throws ServletException, IOException {
+		Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
+
+		// Update the last update time for this user if they are not new
+		HttpSession httpSession = request.getSession(false);
+		if (httpSession != null) {
+			SessionService.touchSession(httpSession.getId());
+		}
+		
+		// Each time metacat is called, see if it has been configured,
+		// and if not, then forward to the administration servlet
+		if (!MetaCatUtil.isMetacatConfigured()) {
+			RequestUtil.forwardRequest(request, response, "/admin?action=configure");
+			return;
+		}
+
+		/*
+		 * logMetacat.debug("Connection pool size: "
+		 * +connPool.getSizeOfDBConnectionPool(),10); logMetacat.debug("Free
+		 * DBConnection number: "
+		 */
+		// If all DBConnection in the pool are free and DBConnection pool
+		// size is greater than initial value, shrink the connection pool
+		// size to initial value
+		DBConnectionPool.shrinkDBConnectionPoolSize();
+
+		// Debug message to print out the method which have a busy DBConnection
+		try {
+			DBConnectionPool pool = DBConnectionPool.getInstance();
+			pool.printMethodNameHavingBusyDBConnection();
+		} catch (SQLException e) {
+			logMetacat.error("Error in MetacatServlet.handleGetOrPost: "
+					+ e.getMessage());
+			e.printStackTrace();
+		}
+
+		try {
+			String ctype = request.getContentType();
+			if (ctype != null && ctype.startsWith("multipart/form-data")) {
+				handleMultipartForm(request, response);
+			} else {
+
+				String name = null;
+				String[] value = null;
+				String[] docid = new String[3];
+				Hashtable<String, String[]> params = new Hashtable<String, String[]>();
+
+				// Check if this is a simple read request that doesn't use the
+				// "action" syntax
+				// These URLs are of the form:
+				// http://localhost:8180/knb/metacat/docid/skinname
+				// e.g., http://localhost:8180/knb/metacat/test.1.1/knb
+				String pathInfo = request.getPathInfo();
+				if (pathInfo != null) {
+					String[] path = pathInfo.split("/");
+					if (path.length > 1) {
+						String docidToRead = path[1];
+						String docs[] = new String[1];
+						docs[0] = docidToRead;
+						logMetacat.debug("READING DOCID FROM PATHINFO: " + docs[0]);
+						params.put("docid", docs);
+						String skin = null;
+						if (path.length > 2) {
+							skin = path[2];
+							String skins[] = new String[1];
+							skins[0] = skin;
+							params.put("qformat", skins);
+						}
+						handleReadAction(params, request, response, "public", null, null);
+						return;
+					}
+				}
+
+				Enumeration<String> paramlist =(Enumeration<String>)request.getParameterNames();
+				while (paramlist.hasMoreElements()) {
+
+					name = (String) paramlist.nextElement();
+					value = request.getParameterValues(name);
+
+					// Decode the docid and mouse click information
+					// THIS IS OBSOLETE -- I THINK -- REMOVE THIS BLOCK
+					// 4/12/2007
+					// MBJ
+					if (name.endsWith(".y")) {
+						docid[0] = name.substring(0, name.length() - 2);
+						params.put("docid", docid);
+						name = "ypos";
+					}
+					if (name.endsWith(".x")) {
+						name = "xpos";
+					}
+
+					params.put(name, value);
+				}
+
+				// handle param is emptpy
+				if (params.isEmpty() || params == null) {
+					return;
+				}
+
+				// if the user clicked on the input images, decode which image
+				// was clicked then set the action.
+				if (params.get("action") == null) {
+					PrintWriter out = response.getWriter();
+					response.setContentType("text/xml");
+					out.println("<?xml version=\"1.0\"?>");
+					out.println("<error>");
+					out.println("Action not specified");
+					out.println("</error>");
+					out.close();
+					return;
+				}
+
+				String action = ((String[]) params.get("action"))[0];
+				logMetacat.info("Action is: " + action);
+
+				// This block handles session management for the servlet
+				// by looking up the current session information for all actions
+				// other than "login" and "logout"
+				String username = null;
+				String password = null;
+				String[] groupnames = null;
+				String sess_id = null;
+				name = null;
+
+				// handle login action
+				if (action.equals("login")) {
+					PrintWriter out = response.getWriter();
+					handleLoginAction(out, params, request, response);
+					out.close();
+
+					// handle logout action
+				} else if (action.equals("logout")) {
+					PrintWriter out = response.getWriter();
+					handleLogoutAction(out, params, request, response);
+					out.close();
+
+					// handle shrink DBConnection request
+				} else if (action.equals("shrink")) {
+					PrintWriter out = response.getWriter();
+					boolean success = false;
+					// If all DBConnection in the pool are free and DBConnection
+					// pool
+					// size is greater than initial value, shrink the connection
+					// pool
+					// size to initial value
+					success = DBConnectionPool.shrinkConnectionPoolSize();
+					if (success) {
+						// if successfully shrink the pool size to initial value
+						out.println("DBConnection Pool shrunk successfully.");
+					}// if
+					else {
+						out.println("DBConnection pool not shrunk successfully.");
+					}
+					// close out put
+					out.close();
+
+					// aware of session expiration on every request
+				} else {
+					// TODO MCD take a closer look at this
+					HttpSession sess = request.getSession(true);
+					SessionData sessionData = null;
+					logMetacat.info("session.isnew: " + sess.isNew()
+							+ "    params.hassessid: " + params.containsKey("sessionid"));
+					if (sess.isNew() && !params.containsKey("sessionid")) {
+						// session expired or has not been stored b/w user
+						// requests
+						logMetacat.info("The session is new or no sessionid is assigned. " 
+								+ "The user is public");
+						sessionData = new SessionData(sess.getId(), "public", null, null);
+						SessionService.registerSession(sessionData);											
+					} else {
+						logMetacat.info("The session is either old or "
+								+ "has sessionid parameter");
+						try {
+							
+							if (params.containsKey("sessionid")) {
+								sess_id = ((String[]) params.get("sessionid"))[0];
+								logMetacat.info("in has sessionid " + sess_id);
+								if (SessionService.isSessionRegistered(sess_id)) {
+									logMetacat.info("find the id " + sess_id
+											+ " in hash table");
+									sessionData = SessionService.getRegisteredSession(sess_id);
+								}
+							} else {
+								// this makes sure there is a session object for
+								// public sessions
+								sess_id = sess.getId();
+								sessionData = new SessionData(sess.getId(), 
+										(String) sess.getAttribute("username"), 
+										(String[]) sess.getAttribute("groups"),
+										(String) sess.getAttribute("password"));
+								SessionService.registerSession(sessionData);
+							}
+						} catch (IllegalStateException ise) {
+							logMetacat.error("Error in handleGetOrPost: this shouldn't "
+									+ "happen: the session should be valid: "
+									+ ise.getMessage());
+						}
+
+						username = (String) sess.getAttribute("username");
+						logMetacat.info("The user name from session is: " + username);
+						password = (String) sess.getAttribute("password");
+						groupnames = (String[]) sess.getAttribute("groupnames");
+//						name = (String) sess.getAttribute("name");
+					}
+
+					// make user user username should be public
+					if (username == null || (username.trim().equals(""))) {
+						username = "public";
+					}
+					logMetacat.info("The user is : " + username);
+				}
+				// Now that we know the session is valid, we can delegate the
+				// request
+				// to a particular action handler
+				if (action.equals("query")) {
+					ServletOutputStream streamOut = response.getOutputStream();
+					PrintWriter out = new PrintWriter(streamOut);
+					handleQuery(out, params, response, username, groupnames, sess_id);
+					out.close();
+				} else if (action.equals("squery")) {
+					ServletOutputStream streamOut = response.getOutputStream();
+					PrintWriter out = new PrintWriter(streamOut);
+					if (params.containsKey("query")) {
+						handleSQuery(out, params, response, username, groupnames, sess_id);
+						out.close();
+					} else {
+						out.println("Illegal action squery without \"query\" parameter");
+						out.close();
+					}
+				} else if (action.trim().equals("spatial_query")) {
+
+					logMetacat
+							.debug("******************* SPATIAL QUERY ********************");
+					ServletOutputStream streamOut = response.getOutputStream();
+					PrintWriter out = new PrintWriter(streamOut);
+					handleSpatialQuery(out, params, response, username, groupnames,
+							sess_id);
+					out.close();
+
+				} else if (action.equals("export")) {
+
+					handleExportAction(params, response, username, groupnames, password);
+				} else if (action.equals("read")) {
+					handleReadAction(params, request, response, username, password,
+							groupnames);
+				} else if (action.equals("readinlinedata")) {
+					handleReadInlineDataAction(params, request, response, username,
+							password, groupnames);
+				} else if (action.equals("insert") || action.equals("update")) {
+					PrintWriter out = response.getWriter();
+					if ((username != null) && !username.equals("public")) {
+						handleInsertOrUpdateAction(request, response, out, params,
+								username, groupnames);
+					} else {
+						response.setContentType("text/xml");
+						out.println("<?xml version=\"1.0\"?>");
+						out.println("<error>");
+						out.println("Permission denied for user " + username + " "
+								+ action);
+						out.println("</error>");
+					}
+					out.close();
+				} else if (action.equals("delete")) {
+					PrintWriter out = response.getWriter();
+					if ((username != null) && !username.equals("public")) {
+						handleDeleteAction(out, params, request, response, username,
+								groupnames);
+					} else {
+						response.setContentType("text/xml");
+						out.println("<?xml version=\"1.0\"?>");
+						out.println("<error>");
+						out.println("Permission denied for " + action);
+						out.println("</error>");
+					}
+					out.close();
+				} else if (action.equals("validate")) {
+					PrintWriter out = response.getWriter();
+					handleValidateAction(out, params);
+					out.close();
+				} else if (action.equals("setaccess")) {
+					PrintWriter out = response.getWriter();
+					handleSetAccessAction(out, params, username);
+					out.close();
+				} else if (action.equals("getaccesscontrol")) {
+					PrintWriter out = response.getWriter();
+					handleGetAccessControlAction(out, params, response, username,
+							groupnames);
+					out.close();
+				} else if (action.equals("getprincipals")) {
+					PrintWriter out = response.getWriter();
+					handleGetPrincipalsAction(out, username, password);
+					out.close();
+				} else if (action.equals("getdoctypes")) {
+					PrintWriter out = response.getWriter();
+					handleGetDoctypesAction(out, params, response);
+					out.close();
+				} else if (action.equals("getdtdschema")) {
+					PrintWriter out = response.getWriter();
+					handleGetDTDSchemaAction(out, params, response);
+					out.close();
+				} else if (action.equals("getlastdocid")) {
+					PrintWriter out = response.getWriter();
+					handleGetMaxDocidAction(out, params, response);
+					out.close();
+				} else if (action.equals("getalldocids")) {
+					PrintWriter out = response.getWriter();
+					handleGetAllDocidsAction(out, params, response);
+					out.close();
+				} else if (action.equals("isregistered")) {
+					PrintWriter out = response.getWriter();
+					handleIdIsRegisteredAction(out, params, response);
+					out.close();
+				} else if (action.equals("getrevisionanddoctype")) {
+					PrintWriter out = response.getWriter();
+					handleGetRevisionAndDocTypeAction(out, params);
+					out.close();
+				} else if (action.equals("getversion")) {
+					response.setContentType("text/xml");
+					PrintWriter out = response.getWriter();
+					out.println(MetaCatVersion.getVersionAsXml());
+					out.close();
+				} else if (action.equals("getlog")) {
+					handleGetLogAction(params, request, response, username, groupnames);
+				} else if (action.equals("getloggedinuserinfo")) {
+					PrintWriter out = response.getWriter();
+					response.setContentType("text/xml");
+					out.println("<?xml version=\"1.0\"?>");
+					out.println("\n<user>\n");
+					out.println("\n<username>\n");
+					out.println(username);
+					out.println("\n</username>\n");
+					if (name != null) {
+						out.println("\n<name>\n");
+						out.println(name);
+						out.println("\n</name>\n");
+					}
+					if (LDAPUtil.isAdministrator(username, groupnames)) {
+						out.println("<isAdministrator></isAdministrator>\n");
+					}
+					if (LDAPUtil.isModerator(username, groupnames)) {
+						out.println("<isModerator></isModerator>\n");
+					}
+					out.println("\n</user>\n");
+					out.close();
+				} else if (action.equals("buildindex")) {
+					handleBuildIndexAction(params, request, response, username,
+							groupnames);
+				} else if (action.equals("login") || action.equals("logout")) {
+					/*
+					 * } else if (action.equals("protocoltest")) { String
+					 * testURL = "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9";
+					 * try { testURL = ((String[]) params.get("url"))[0]; }
+					 * catch (Throwable t) { } String phandler = System
+					 * .getProperty("java.protocol.handler.pkgs");
+					 * response.setContentType("text/html"); PrintWriter out =
+					 * response.getWriter(); out.println("<body
+					 * bgcolor=\"white\">"); out.println("<p>Handler property:
+					 * <code>" + phandler + "</code></p>"); out.println("<p>Starting
+					 * test for:<br>"); out.println(" " + testURL + "</p>");
+					 * try { URL u = new URL(testURL); out.println("<pre>");
+					 * out.println("Protocol: " + u.getProtocol());
+					 * out.println(" Host: " + u.getHost()); out.println(" Port: " +
+					 * u.getPort()); out.println(" Path: " + u.getPath());
+					 * out.println(" Ref: " + u.getRef()); String pquery =
+					 * u.getQuery(); out.println(" Query: " + pquery);
+					 * out.println(" Params: "); if (pquery != null) { Hashtable
+					 * qparams = MetaCatUtil.parseQuery(u.getQuery()); for
+					 * (Enumeration en = qparams.keys(); en .hasMoreElements();) {
+					 * String pname = (String) en.nextElement(); String pvalue =
+					 * (String) qparams.get(pname); out.println(" " + pname + ": " +
+					 * pvalue); } } out.println("</pre>"); out.println("</body>");
+					 * out.close(); } catch (MalformedURLException mue) {
+					 * System.out.println( "bad url from
+					 * MetacatServlet.handleGetOrPost");
+					 * out.println(mue.getMessage()); mue.printStackTrace(out);
+					 * out.close(); }
+					 */
+				} else {
+					PrintWriter out = response.getWriter();
+					out.println("<?xml version=\"1.0\"?>");
+					out.println("<error>");
+					out
+							.println("Error: action not registered.  Please report this error.");
+					out.println("</error>");
+					out.close();
+				}
+
+				// util.closeConnections();
+				// Close the stream to the client
+				// out.close();
+
+				// Schedule the sitemap generator to run periodically
+				scheduleSitemapGeneration(request);
+			}
+		} catch (PropertyNotFoundException pnfe) {
+			String errorString = "Critical property not found: " + pnfe.getMessage();
+			logMetacat.error(errorString);
+			throw new ServletException(errorString);
+		} catch (UtilException ue) {
+			String errorString = "Utility error: " + ue.getMessage();
+			logMetacat.error(errorString);
+			throw new ServletException(errorString);
+		}
+	}
     
-    /////////////////////////////// METACAT SPATIAL ///////////////////////////
+    // ///////////////////////////// METACAT SPATIAL ///////////////////////////
     
     /**
-     * handles all spatial queries -- these queries may include any of the
-     * queries supported by the WFS / WMS standards
-     *
-     * handleSQuery(out, params, response, username, groupnames,
-     *                        sess_id);
-     */
-    private void handleSpatialQuery(PrintWriter out, Hashtable params,
+	 * handles all spatial queries -- these queries may include any of the
+	 * queries supported by the WFS / WMS standards
+	 * 
+	 * handleSQuery(out, params, response, username, groupnames, sess_id);
+	 */
+    private void handleSpatialQuery(PrintWriter out, Hashtable<String, String[]> params,
             HttpServletResponse response,
             String username, String[] groupnames,
-            String sess_id) {
+            String sess_id) throws PropertyNotFoundException {
         
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
         
-        if ( !MetaCatUtil.getOption("runSpatialOption").equals("true") ) {
+        if ( !PropertyService.getProperty("runSpatialOption").equals("true") ) {
             response.setContentType("text/html");
             out.println("<html> Metacat Spatial Option is turned off </html>");
             out.close();
